import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Arrays;

class Comms {
    BufferedReader reader;
    PrintWriter writer;
}

public class Mine {
    public static void event_loop(Comms comms) throws Exception {

        Igralec t;
        ArrayList<String> cmda;

        while (true) {
            cmda = new ArrayList<String>(Arrays.asList(comms.reader.readLine().split(" ")));

            if (cmda.get(0).equals("ADIJO")) return;
            if (cmda.get(0).startsWith("KONEC_IGRE")) {
            	comms.writer.write("KONCAL\n");
            	comms.writer.flush();
            	continue;
            }
            if (!cmda.get(0).equals("ZACNI")) throw new Exception("Napaka pri komunikaciji z ocenjevalnim programom.");

            t = new Igralec();
            t.zacni_igro(Integer.parseInt(cmda.get(1)), Integer.parseInt(cmda.get(2)), Integer.parseInt(cmda.get(3)));
            comms.writer.write("ZACEL\n");
            comms.writer.flush();

            while (true) {
                cmda = new ArrayList<String>(Arrays.asList(comms.reader.readLine().split(" ")));

                if (cmda.get(0).equals("ADIJO")) return;
                if (cmda.get(0).equals("KONEC_IGRE")) {
                	t.konec_igre(cmda.get(1));
                    t = null;
                    comms.writer.write("KONCAL\n");
                    comms.writer.flush();
                    break;
                } else if (cmda.get(0).equals("POTEZA?")) {
                	Celica c = t.naslednja_poteza();
                	comms.writer.write("POTEZA " + c.x.toString() + " " + c.y.toString() + "\n");
                	comms.writer.flush();
                } else if (cmda.get(0).equals("IZID")) {
                	t.izid(Integer.parseInt(cmda.get(1)), Integer.parseInt(cmda.get(2)), Integer.parseInt(cmda.get(3)) > 0, Integer.parseInt(cmda.get(4)));
                	comms.writer.write("MHM\n");
                	comms.writer.flush();
                } else {
                }
            }
        }
    }

    public static void connect(String Hostname, Comms comms) throws Exception {
        Socket client = new Socket(Hostname, 1180);

        comms.reader = new BufferedReader(new InputStreamReader(client.getInputStream()));
        comms.writer = new PrintWriter(new OutputStreamWriter(client.getOutputStream()));

        String server = comms.reader.readLine();
        System.out.println(server);

        comms.writer.println("AVE " + Igralec.Ime);
        comms.writer.flush();

        String succ = comms.reader.readLine();
        if (!succ.equals("PRIJAVA USPESNA")) throw new Exception("Prijava na ocenjevalni program neuspesna" + succ);
    }

    public static void main(String argv[]) throws Exception {
        String Hostname;
        if (argv.length < 1) Hostname = "localhost";
        else Hostname = argv[0];

        Comms comms = new Comms();
        connect(Hostname, comms);
        event_loop(comms);

    }
}
